<?php
// PI_Contstants.php
// all Contants for project swimming pool
// PI Ports

define("GPIOPATH","/sys/class/gpio/");
define("GPIO_0", 17);				// Pi Pin 11
define("GPIO_1",18);				// Pi Pin 12
define("GPIO_2",27);				// Pi Pin 13
define("GPIO_3",22);				// Pi Pin 15
define("GPIO_4",23);				// Pi Pin 16
define("GPIO_5",24);				// Pi Pin 18
define("GPIO_6",25);				// Pi Pin 22

//Reserved
define("GPIO_7",4);					// Pi Pin 7		GPIO_GCLOCK  1Wire Devices

//ab Rev. B
define("GPIO_21",5);				// Pi Pin 29
define("GPIO_22",6);				// Pi Pin 31
define("GPIO_23",13);				// Pi Pin 33
define("GPIO_24",19);				// Pi Pin 35
define("GPIO_25",26);				// Pi Pin 37
define("GPIO_26",12);				// Pi Pin 32
define("GPIO_27",16);				// Pi Pin 36
define("GPIO_28",20);				// Pi Pin 38
define("GPIO_29",21);				// Pi Pin 40

// 1Wire Devices
define("W1_PATH","/sys/devices/w1_bus_master1/");

// OUT ports
define("MOTOR",GPIO_21);			// Pumpe ein/aus
define("HEAT_ON",GPIO_22);			// Ventil ein
define("HEAT_OFF",GPIO_23);			// ventil aus

// IN ports
define("WARTUNG",GPIO_27);			// Wartung Schalter
define("SENSOR_1",GPIO_28);			// Wassersensor 1
define("SENSOR_2",GPIO_29);			// Wassersensor 2

// definitions for SQL
define('SQL_DB','bad');				// Name Datenbank
define('SQL_USER','root');			// Database User
define('SQL_PWD','.sqlpwd');		// Database Password

// defines for database tables
// every table
define("ID",0);						// table offset
// table status
define("STAT_SEASON",1);			// table offset season
define("STAT_MOTOR",2);				// table offset motor on/off
define("STAT_HEAT",3);				// table offset heating on/off
define("STAT_SERVICE",4);			// table offset service
define("STAT_START",5);				// table offset startime
define("STAT_STOP",6);				// table offset stop time
define("STAT_T_MAX",7);				// table offset maximum temperature
define("STAT_NIGHT",8);				// table offset night
define("STAT_TIME",9);				// table offset timestamp
define("STAT_OFFSET",10);			// table offset water offset
define("STAT_T_ERROR",11);			// table offset temperature error not used
define("STAT_MAX_OK",12);			// table offset max temperature ok
define("STAT_H_TEMP",13);			// table offset heating temperature
define("STAT_W_TEMP",14);			// table offset water temperature

// table temperatur
define("TEMP_WATER",1);				// table offset water temperature
define("TEMP_SOLAR",2);				// table offset solar temperature
define("TEMP_TS",3);				// table offset temperature timsestamp
define("TEMP_MOTOR",4);				// table offset motor status
define("TEMP_HEAT",5);				// table offset heating status

// LCD Display 2 lines - 16 Characters - hd4478 compatible
//Definitions
define("LCD_RS_line",GPIO_4);
define("LCD_RW_line",GPIO_5);
define("LCD_E_line",GPIO_6);
define("LCD_DATA4_line",GPIO_0);
define("LCD_DATA5_line",GPIO_1);
define("LCD_DATA6_line",GPIO_2);
define("LCD_DATA7_line",GPIO_3);
//define("LCD_BUSY_bit",GPIO_?);

define("LCD_READ",1);
define("LCD_WRITE",0);
define("LCD_CLEAR",0x01);
define("LCD_CURSOR_HOME",0x02);
define("LCD_SET_DISPLAY",0x80);		//Adresse einstellen
define("LCD_DISPLAY_OFF",0x08);
define("LCD_DISPLAY_ON",0xC0);		// Anpassen und maskieren
define("LCD_CURSOR_OFF",0x0C);
define("LCD_CURSOR_ON",0x02);
define("LCD_BLINKING_OFF",0x00);
define("LCD_BLINKING_ON",0x01);
define("LCD_FUNCTION_4BIT",0x20);
define("LCD_FUNCTION_8BIT",0x30);
define("LCD_2_LINES",0x10);


define("LCD_WIDTH", 0x10);        	// Zeichen je Zeile
define("LCD_LINE_1", 0x80);     	// Adresse der ersten Display Zeile
define("LCD_LINE_2", 0xC0);     	// Adresse der zweiten Display Zeile
define("LCD_CHR", "1");				// Wert fuer RS
define("LCD_CMD", "0");				// Wert für RS

DEFINE("R_ON",0);					// Relais arbeiten inverteiert
DEFINE("R_OFF",1);
?>
