<?PHP
// 1 Wire Library
// gruen = GND
// schwarz = Data I/O
// rot = VDD

require_once('ALL_Constants.php');

/**
 * Stellt die Anzahl der DS1820 Sensoren fest
 * liest die IDs und liefert sie als array zurück
 * falss keine Sensoren gefundne werden wird ein leeres Array zuückgeliefert
 * @return array $senors_ids
 */
function w1_find()
// find 1 Wire Devices
// on error return empty array
{
//	echo 'w1_find get count<br>';
	$sensor_ids = array();
	$filename = W1_PATH.'w1_master_slave_count';
//	echo $filename.'<br>';
	if ($file = fopen($filename,'r'))
	{
      	$sensor_count = fgets($file); 		// Anzahl der Sensoren
//     	echo $sensor_count.'<br>';
       	fclose ($file);
//		echo 'w1_find gez IDs<br>';
		$filename = W1_PATH.'w1_master_slaves';
//		echo $filename.'<br>';
		if ($file = fopen($filename, 'r'))
       	{
			for ($count = 0; $count <  $sensor_count; $count++)
			{
				$id = fgets($file);
				$id = trim($id);
				$sensor_ids[$count] = $id;
			}
        	fclose ($file);
       	}
	}
	return ($sensor_ids);
}



/**
 * Liest Temperarur eine durchdie ID beststimmten Sensors
 * im Fehlerfall 999999
 *
 * @param string $id
 * @return temperatur
 */
function w1_read ($id)
// lesen eines 1 Wire Devices
{
        $name = W1_PATH.$id.'/w1_slave';
//      echo $name.'<br>';
        if ($file = fopen($name, 'r'))
        {
        	$line = fgets($file);				// read frst line
	        if (preg_match('/YES/',$line))		// check if value valid
    	    {
                $line = fgets($file);			// read next line with value
//              echo $line.'<br>';
                $pos = strpos($line,'=');		// get pos of value
                $temp = substr($line,$pos+1);	// read temparature
                if ($temp == '85000')			// Messfehler
                {
                	$temp =999999;					
                }
//              echo $temp.'<br>';
	        }
			else
			{
				$temp =999999;
			}
	        fclose($file);
        }
        else 
        {
        	$temp ='error';
        }
        return ($temp);
}

?>
