#	Constants for Poolsteuerung
# constants.py

# WiringPI	BCM		HW Pin
# GPIO_0	BCM 17	Pin 11				SPI1 CE1
GPIO_0	= 11
# GPIO_1	BCM 18	Pin 12	PCM CLK		SPI1 CE0
GPIO_1 = 12
# GPIO_2	BCM 27	Pin 13
GPIO_2 = 13
# GROUND			Pin 14
# GPIO_3	BCM 22	Pin 15
GPIO_3 = 15
# GPIO_4	BCM 23	Pin 16
GPIO_4 = 16
# 3V3				Pin 17
# GPIO_5	BCM 24	Pin 18
GPIO_5 = 17
# GPIO_6	BCM 25	Pin 22
GPIO_6 = 22
# GPIO_7	BCM 4	Pin 7	GPCLK0	1Wire Data
# 3V3				Pin 1
# 5V				Pin 2
# GPIO_8	BCM 2	Pin 3	I2C Data
# 5V				Pin 4
# GPIO_9	BCM 3	Pin 5	I2C Clock
# GROUND			Pin 6
# GPIO_10	BCM 8	Pin 24				SPI0 CE0
# GROUND			Pin 25
# GPIO_11	BCM 7	Pin 26				SPI0 CE1
# GPIO_12	BCM 10	Pin 19				SPI0 MOSI
# GROUND			Pin 20
# GPIO_13	BCM 9	Pin 21				SPIO MOSO
# GPIO_14	BCM 11	Pin 23				SPIO SCLK
# GPIO_15	BCM 14	Pin 8	TXD
# GROUND			Pin 9
# GPIO_16	BCM 15	Pin 10	RXD
# ab Rev. B
# GPIO_21	BCM 5	Pin 29	GPCLK1
# GROUND			Pin 30
# GPIO_22	BCM 6	Pin 31	GPCLK2
# GPIO_23	BCM 13	Pin 33
# GROUND			Pin 34
# GPIO_24	BCM 19	Pin 35	PCM FS		SPI1 MISO
# GPIO_25	BCM 26	Pin 37
# GPIO_26	BCM 12	Pin 32
# GPIO_27	BCM 16	Pin 36				SPI1 CE2
# GPIO_28	BCM 20	Pin 38	PCM DIN		SPI1 MOSI
# GROUND			Pin 39
# GPIO_29	BCM 21	Pin 40	PCM DOUT	SPI1 SCLK
# GPIO_30	BCM 0	Pin 27	I2C EEPROM Data
# GPIO_31	BCM 12	Pin 22	I2C EEPROM Clock

#	Programm uses RasPi PIN umbers

PUMPE = 29			# GPIO_21	Relais 1
HEAT_ON = 33		# GPIO_23	Relais 3
HEAT_OFF = 31		# GPIO_22	Relais 4

WARTUNG = 36		# GPIO_27	Schalter Wartung
SENSOR_1 = 38		# GPIO_28	Wassersensor 1
SENSOR_2 = 40		# GPIO_29	Wassersensor 2

# Offsets in Tabelle status
STAT_ID = 0
STAT_SEASON = 1
STAT_PUMPE = 2
STAT_HEAT = 3
STAT_SERVICE = 4
STAT_START = 5
STAT_STOP = 6
STAT_MAX = 7
STAT_NIGTH = 8
STAT_DATE = 9
STAT_OFFSET = 10
STAT_T_ERROR = 11
STAT_MAX_OK = 12
STAT_H_TEMP = 13
STAT_W_TEMP = 14
STAT_COUNT = 15

# Offsets in Tabelle Temperatur History
TEMO_ID = 0				# ID
TEMP_WATER = 1			# Wassertemperatur
TEMP_SOLAR = 2			# Solartemperatur
TEMP_OFFSET = 3			# Temperatur Offset
TEMP_PUMPE = 4			# Pumpe Ein
TEMP_HEAT = 5			# Heizung Ein
#TEMP_SOLL = 6			# Temperatur Soll

# LCD Pins
LCD_RS_line = GPIO_4
LCD_RW_line = GPIO_5
LCD_E_line = GPIO_6
LCD_DATA4_line = GPIO_0
LCD_DATA5_line = GPIO_1
LCD_DATA6_line = GPIO_2
LCD_DATA7_line = GPIO_3

LCD_READ = 1
LCD_WRITE = 0
LCD_CLEAR = 0x01
LCD_CURSOR_HOME = 0x02
LCD_SET_DISPLAY = 0x80		# Adresse einstellen
LCD_DISPLAY_OFF = 0x08
LCD_DISPLAY_ON = 0xC0
LCD_BLINKING_OFF = 0x00
LCD_BLINKING_ON = 0x01
LCD_FUNCTION_4BIT = 0x20
LCD_FUNCTION_8BIT = 0x30
LCD_2_LINES = 0x10

LCD_WIDTH = 0x10			# Zeichen pro Zeile
LCD_LINE_1 = 0x80			# Adresse 1. Zeile
LCD_LINE_2 = 0xC0			# Adresse 2. Zeile
LCD_CHR = 1					# Registerselect Character
LCD_CMD = 0					# Registerselect Command
