#!/usr/bin/python3
# coding=utf-8
# loop.py
#----------------

import os, sys, time, pymysql
import RPi.GPIO as GPIO

from constant import * 

#	Heizungstemperatur auslesen
def Solar():
	test = True
	try:
		# 1-wire Slave Datei lesen
		file = open('/sys/bus/w1/devices/10-000801d5884f/w1_slave')
		filecontent = file.read()
		file.close()
	except IOError:
		test = False
	if test == False:
		rueckgabewert = 88
	else:
		# Temperaturwerte auslesen und konvertieren
		stringvalue = filecontent.split("\n")[1].split(" ")[9]
		temperature = float(stringvalue[2:]) / 1000
		# Temperatur ausgeben
		rueckgabewert = '%6.2f' % temperature 
	return(rueckgabewert)

#	Wassertemperatur auslesen
def Wasser():
	test = True
	try:
		# 1-wire Slave Datei lesen
		file = open('/sys/bus/w1/devices/10-000801d5bd1b/w1_slave')
		filecontent = file.read()
		file.close()
	except IOError:
		test = False
	if test == False:
		rueckgabewert= 88
	else:
		# Temperaturwerte auslesen und konvertieren
		stringvalue = filecontent.split("\n")[1].split(" ")[9]
		temperature = float(stringvalue[2:]) / 1000
		# Temperatur ausgeben
		rueckgabewert = '%6.2f' % temperature
	return(rueckgabewert)

#	Status Record lessen
def Get_status():
	try:
		db = pymysql.connect("localhost","root",".sqlpwd","bad",)
	except:
		print ("error connect mysql")
	try:
		cursor = db.cursor()
	except:
		print ("Error cursor")
	sql = "SELECT * FROM status;"
	try:
		cursor.execute(sql)
		results = cursor.fetchall()
		for row in results:
			Id = row[STAT_ID]
			Season = row[STAT_SEASON]
			Pumpe = row[STAT_PUMPE]
			Heat = row[STAT_HEAT]
			Service = row[STAT_SERVICE]
			Start = row[STAT_START]
			Stop = row[STAT_STOP]
			Max = row[STAT_MAX]
			Night = row[STAT_NIGTH]
			Date = row[STAT_DATE]
			Offset = row[STAT_OFFSET]
			T_Error = row[STAT_T_ERROR]
			Count = row[STAT_COUNT]
	except MySQLError as e:
		print ("error reading status")
	db.close()
	return(Id, Season, Pumpe, Heat, Service, Start, Stop, Max, Night,\
		Date, Offset, T_Error, Count)

#	Status Record update
def Update_status(Pumpe, Heat, Service, Night, W_temp, H_temp, Max_ok, Counter):
#	print ("update status")							# debug only
	try:
		db = pymysql.connect("localhost","root",".sqlpwd","bad",)
	except:
		print ("error connect mysql")
	try:
		cursor = db.cursor()
	except:
		print ("Error cursor")
	sql = ("UPDATE status SET motor=%s, heat=%s, service=%s, \
		night=%s, max_ok=%s, h_temp=%s, \
		w_temp=%s, count=%s WHERE id=1" \
		%(Pumpe, Heat, Service, Night, Max_ok, H_temp, W_temp, Counter))
	try:
#		print ("Update ok")				# Debug only
		cursor.execute(sql)
		db.commit()
	except:
		print ("update failed")
		db.rollback()
	db.close()


#	Heizung einschalten
def HEAT_EIN():
	GPIO.setup(HEAT_OFF, GPIO.OUT)		# set Mode OUT
	GPIO.output(HEAT_OFF, GPIO.HIGH)	# HEAT_OF deaktivieren
	GPIO.setup(HEAT_ON, GPIO.OUT)		# set Mode OUT
	GPIO.output(HEAT_ON, GPIO.LOW)		# HEAT_ON aktivieren

#	Heizung ausschalten
def HEAT_AUS():
	GPIO.setup(HEAT_ON, GPIO.OUT)		# set Mode OUT
	GPIO.output(HEAT_ON, GPIO.HIGH)		# HEAT_ON deaktivieren
	GPIO.setup(HEAT_OFF, GPIO.OUT)		# set Mode OUT
	GPIO.output(HEAT_OFF, GPIO.LOW)		# HEAT_OFF aktivieren

#	Heizung neutral
def HEAT_NEUTRAL():
	GPIO.setup(HEAT_ON, GPIO.OUT)		# set Mode OUT
	GPIO.output(HEAT_ON, GPIO.HIGH)		# HEAT_ON deaktivieren
	GPIO.setup(HEAT_OFF, GPIO.OUT)		# set Mode OUT
	GPIO.output(HEAT_OFF, GPIO.HIGH)	# HEAT_OFF deaktivieren

#	Pumpe einschalten
def PUMPE_EIN():
	GPIO.setup(PUMPE, GPIO.OUT)			# set Mode OUT
	GPIO.output(PUMPE, GPIO.LOW)		# Out LOW Relais schaltet

#	Pumpe ausschalten
def PUMPE_AUS():
	GPIO.setup(PUMPE, GPIO.OUT)			# set Mode OUT
	GPIO.output(PUMPE, GPIO.HIGH)		# Out HIGH Relais aus 

#	Wartung einlesen, TRUE oder FALSE zurückgeben
#	Schalter unten = 0 = LOW
def Wartung():
	GPIO.setup(WARTUNG, GPIO.IN, pull_up_down = GPIO.PUD_UP)		# set Mode IN
	if GPIO.input(WARTUNG) == GPIO.LOW:
		status = False
	else:
		status = True
	return(status)

#	Minuten aus aktueller Zeit berechen
def Minutes(now):
	minutes = now.tm_hour * 60
	minutes = minutes + now.tm_min
	return(minutes)

#	Minuten aus Staus berechnen
def Minutes_2(zeit):
	min = zeit.split(':')
	a = int(min[0])
	b = int(min[1])
	c = (a * 60) + b
	return(c)

GPIO.setmode(GPIO.BOARD)				# set to Pin numbers
GPIO.setwarnings(False)

#	aktuelle temperature einlesen
heizungtemp  = Solar()
wassertemp = Wasser()

#	Status lesen für Vorgabetemperature
Id, Season, Pumpe, Heat, Service, Start, Stop, Max, Night, \
Date, Offset, T_Error, Counter = Get_status()

Start = str(Start)						# convert to string
Stop = str(Stop)						# convert to string
Start = Minutes_2(Start)				# return Starttime as Minutes
Stop = Minutes_2(Stop)					# return Stoptime as Minutes

jetzt = Minutes(time.localtime())		# get actuell time
service = Wartung()						# get Wartungs switch state
#print (service)						# Debug only
heizungtemp  = float(Solar())			# get Heizungstemperature
H_temp = int(heizungtemp)				# für Status
wassertemp = float(Wasser())			# get Wassertemperature
W_temp = int(wassertemp)				# für Status

if Season == 1:							# Sommer
#	print ("Sommer")					# Debug only
	if wassertemp >= Max:				# Soll erreicht
		Max_ok = 1						# Status setzen
	else:								# Soll nicht erreicht
		Max_ok = 0						# Stautus setzen
	if service == False:				# kein Service
		Service = 0						# Status setzen
#		print ("Service 0")				# Debug only
		if (jetzt > Start) and (jetzt < Stop): #  aktuelle Zeit > START & aktuelle Zeit < ENDE
			Night = 0					# Status setzen
			Pumpe = 1					# Status setzen
			PUMPE_EIN()					# Pumpe Ein
#			print ("Pumpe Ein")			# Debug only
			if (heizungtemp > (wassertemp + Offset)) and (wassertemp < Max):	# heizen
				Heat = 1				# Status setzen
				HEAT_EIN()				# Heizung Ein
#				print ("Heizung Ein")	# Debug only
			else:						# Heiztemperatur unzureichend oder Wasser warm genug
				Heat = 0				# Status setzen
				HEAT_AUS()				# Heizung Aus
#				print ("Heizung Aus")	# Debug only
		else:							# ausserhalb Zeit (Nacht)
#			print ("Nacht")				# Debug only
			Pumpe = 0					# Status setzen
			Night = 1					# Status setzen
			PUMPE_AUS()					# Pumpe Aus
			Heat = 0					# Status setzen
			HEAT_NEUTRAL()				# Stellmotor stromlos
	else:								# Service
#		print ("Service 1")				# Debug only
		Service = 1						# Status setzen
		Pumpe = 0						# Status setzen
		PUMPE_AUS()						# Pumpe Aus
		Heat = 0						# Status setzen
		HEAT_NEUTRAL()					# Stellmotor stromlos
else:									# Winter = kein Betrieb
#	print ("Winter")					# Debug only
	Pumpe = 0							# Status setzen
	PUMPE_AUS()							# Pumpe aus
	Heat = 0							# Status setzen
	HEAT_NEUTRAL()						# Stellmotor Stromlos

# Status aktualisieren
Counter = int(Counter)
Counter +=1
Update_status(Pumpe, Heat, Service, Night, W_temp, H_temp, Max_ok, Counter)

# logdatei aktualisieren
#Insert_temperatur(W_temp, H_temp, Pumpe, Heat, Service, Offset)

#END
